<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/29/2008 *
 * ===================                          Last change: 09/29/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-refback.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Refback and ref overview                         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Ref-Back und Ref-Uebersicht                      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version number
setThisExtensionVersion('0.0.3');

// Version history array (add more with , '0.0.1' and so on)
setExtensionVersionHistory(array('0.0.0','0.0.1', '0.0.2', '0.0.3'));

switch (getExtensionMode()) {
	case 'register': // Do stuff when installation is running
		// SQL commands to run
		addDropTableSql('user_refs');
		addCreateTableSql('user_refs', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`level` smallINT(6) UNSIGNED NOT NULL DEFAULT 0,
`refid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`refback` float(4,1) NOT NULL DEFAULT 0.0,
`points` FLOAT(20,5) DEFAULT 0.00000 NOT NULL,
PRIMARY KEY (`id`),
UNIQUE `user_refid` (`userid`, `level`, `refid`),
INDEX (`level`),
INDEX (`refid`)",
			'User Referals With Refback');
		addMemberMenuSql('main', 'refback', 'Ref-Back einstellen', 4);

		// Execute this special file on registration
		addIncludeToPool('extension', 'inc/gen_refback.php');
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addDropTableSql('user_refs');
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `what`='refback'");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `what` IN('config_refback','list_refback')");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_refsystem` SET level=level-1");
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='Y', `locked`='N' WHERE `what` IN('refback','reflist') LIMIT 2");
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='N', `locked`='Y' WHERE `what` IN('refback','reflist') LIMIT 2");
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				addConfigAddSql('refback_enabled', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");
				addConfigAddSql('refback_min_perc', 'TINYINT(3) NOT NULL DEFAULT 0');
				addConfigAddSql('refback_max_perc', 'TINYINT(3) NOT NULL DEFAULT 100');
				addAdminMenuSql('setup', 'config_refback', 'Refback', '&Auml;ndern Sie Einstellungen zum Refback, wie z.B. Minimum- und Maximum-Prozente, was die Mitglieder einstellen d&uuml;rfen.', 15);
				addAdminMenuSql('user', 'list_refback', 'Refback auflisten', 'Refback aller Mitglieder auflisten.', 15);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Refback-System ist nun ein-/ausschaltbar und minimale/maximale Refback-Prozente sind festlegbar.");
				break;

			case '0.0.2': // SQL queries for v0.0.2
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_user_refs` CHANGE `userid` `userid` BIGINT(20) UNSIGNED NULL DEFAULT NULL');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_user_refs` CHANGE `level` `level` SMALLINT(6) UNSIGNED NULL DEFAULT NULL');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_user_refs` CHANGE `refid` `refid` BIGINT(20) UNSIGNED NULL DEFAULT NULL');
				addExtensionSql('DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_user_refs` WHERE `userid` IS NULL OR `refid` IS NULL OR `level` IS NULL');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Updates von ext-user hier her verschoben.");
				break;

			case '0.0.3': // SQL queries for v0.0.3
				addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_points_data` (`subject`, `column_name`, `locked_mode`, `payment_method`) VALUES ('refback','points','LOCKED','DIRECT')");

				// This depends on ext-sql_patches
				addExtensionDependency('sql_patches');

				// Update notes
				setExtensionUpdateNotes("Refback-Gutschriften werden nun &uuml;ber die Tabelle <strong>{OPEN_CONFIG}_MYSQL_PREFIX{CLOSE_CONFIG}_points_data</strong> verwaltet.");
				break;
		} // END - switch
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes
		break;

	case 'init': // Do stuff when extension is initialized
		break;

	default: // Unknown extension mode
		logDebugMessage(__FILE__, __LINE__, sprintf("Unknown extension mode %s in extension %s detected.", getExtensionMode(), getCurrentExtensionName()));
		break;
} // END - switch

// [EOF]
?>
