<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 04/24/2005 *
 * ===================                          Last change: 05/12/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-edit_sponsor.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Edit sponsor account                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sponsorenaccount aendern                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

if ((isGetRequestParameterSet('id')) && (isGetRequestParameterSet('mode'))) {
	// Check for selected sponsor
	$result_main = SQL_QUERY_ESC("SELECT
	`id`, `company`, `position`, `gender`, `surname`, `family`,
	`street_nr1`, `street_nr2`, `zip`, `city`, `country`,
	`phone`, `fax`, `cell`, `email`, `url`, `tax_ident`,
	`receive_warnings`, `warning_interval`
FROM
	`{?_MYSQL_PREFIX?}_sponsor_data`
WHERE
	`id`=%s
LIMIT 1",
		array(bigintval(getRequestParameter('id'))), __FILE__, __LINE__);
	if (SQL_NUMROWS($result_main) == 1) {
		// Load sponsor details
		$content = SQL_FETCHARRAY($result_main);

		//  Warning because low points
		$content['receive_warnings'] = addSelectionBox('yn', $content['receive_warnings'], 'receive_warning');
		$content['warning_interval'] = createTimeSelections($content['warning_interval'], 'warning_interval', 'MWDh');

		// Init variables here
		$TPL = sprintf("admin_edit_sponsor_%s", getRequestParameter('mode'));
		initSqls();

		// Sponsor was found
		if ((isFormSent()) || (isFormSent('edit'))) {
			// Perform action on mode
			switch (getRequestParameter('mode')) {
				case 'add_points': // Add points
					if (bigintval(postRequestParameter('points')) > 0) {
						// Replace german decimal comma with computer's decimal dot
						$points = bigintval(convertCommaToDot(postRequestParameter('points')));

						// Add points to account
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_sponsor_data` SET `points_amount`=`points_amount`+%s WHERE `id`=%s LIMIT 1",
							array($points, bigintval(getRequestParameter('id'))), __FILE__, __LINE__);

						// Remember points /reason for the template
						$content['points'] = $points;
						$content['reason'] = postRequestParameter('reason');

						// Send email
						$message = loadEmailTemplate('sponsor_add_points', $content);
						sendEmail($content['email'], '{--ADMIN_SPONSOR_ADD_POINTS_SUBJECT--}', $message);
						$message = '{--ADMIN_SPONSOR_POINTS_ADDED--}';
					} else {
						// No points entered to add!
						$message = '{--ADMIN_SPONSOR_NO_POINTS_TO_ADD--}';
					}
					break;

				case 'sub_points': // Subtract points
					if (bigintval(postRequestParameter('points')) > 0) {
						// Replace german decimal comma with computer's decimal dot
						$points = bigintval(convertCommaToDot(postRequestParameter('points')));

						// Add points to account
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_sponsor_data` SET `points_used`=`points_used`+%s WHERE `id`=%s LIMIT 1",
							array($points, bigintval(getRequestParameter('id'))), __FILE__, __LINE__);

						// Remember points /reason for the template
						$content['points'] = $points;
						$content['reason'] = postRequestParameter('reason');

						// Send email
						$message = loadEmailTemplate('sponsor_sub_points', $content);
						sendEmail($content['email'], '{--ADMIN_SPONSOR_SUB_POINTS_SUBJECT--}', $message);
						$message = '{--ADMIN_SPONSOR_POINTS_SUBTRACTED--}';
					} else {
						// No points entered to add!
						$message = '{--ADMIN_SPONSOR_NO_POINTS_TO_SUBTRACT--}';
					}
					break;

				case 'edit': // Edit sponsor account
					$PASS = true;
					if ((postRequestParameter('pass1') != postRequestParameter('pass2')) || ((!isPostRequestParameterSet('pass1')) && (!isPostRequestParameterSet('pass1')))) {
						// Remove passwords
						unsetPostRequestParameter('pass1');
						unsetPostRequestParameter('pass2');
						$PASS = false;
					} // END - if

					// Convert time selection
					$DATA = array(); $id = 'warning_interval_ye'; $skip = false;
					convertSelectionsToEpocheTime(postRequestArray(), $DATA, $id, $skip);

					// Save the sponsor
					handleSponsorRequest(postRequestArray());

					// Convert some data for the email template
					postRequestParameter('gender'          , '{%pipe,translateComma=' . postRequestParameter('gender') . '%}');
					postRequestParameter('warning_interval', '{%pipe,createFancyTime=' . postRequestParameter('warning_interval') . '%}');

					if ($PASS === false) setPostRequestParameter('pass1', '{--SPONSOR_PASS_UNCHANGED--}');

					// Load email template and send the mail away
					$message = loadEmailTemplate('admin_sponsor_edit', postRequestArray(), false);
					sendEmail(postRequestParameter('email'), '{--ADMIN_SPONSOR_EDIT_SUBJECT--}', $message);
					break;

				default: // Unknown mode
					logDebugMessage(__FILE__, __LINE__, sprintf("Unknown mode %s detected.", getRequestParameter('mode')));
					$message = '{%message,ADMIN_SPONSOR_INVALID_MODE=' . getRequestParameter('mode') . '%}';
					break;
			}

			if (!empty($message)) {
				// Output message
				displayMessage($message);
			} // END - if
		} elseif (isFileReadable(sprintf("%stemplates/%s/html/admin/%s.tpl", getPath(), getLanguage(), $TPL))) {
			// Create mailto link
			$content['contact'] = '<a href="' . generateSponsorEmailLink($content['email'], 'sponsor_data') . '">' . $content['surname'] . ' ' . $content['family'] . '</a>';

			// Load mode template
			loadTemplate($TPL, false, $content);
		} else {
			// Template not found
			displayMessage('{%message,ADMIN_SPONSOR_MODUS_TPL_404', getRequestParameter('mode') . '%}');
		}
	} else {
		// Sponsor not found
		displayMessage('{%message,ADMIN_SPONSOR_404=' . bigintval(getRequestParameter('id')) . '%}');
	}

	// Free result
	SQL_FREERESULT($result_main);
} else {
	// Not called by what-list_sponsor.php
	displayMessage('{--ADMIN_CALL_NOT_DIRECTLY--}');
}

// [EOF]
?>
