<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/22/2005 *
 * ===================                          Last change: 10/22/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_beg.php                                *
 * -------------------------------------------------------------------- *
 * Short description : List members in begging-rallye                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mitglieder in Bettel-Rallye auflisten            *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

if (isBegRallyeEnabled()) {
	// Shall I withdraw now?
	if (isPostRequestParameterSet('withdraw')) {
		// Okay, let's prepare...
		$curr = getMonth() - 1;
		if (strlen($curr) == 1) $curr = '0' . $curr;
		updateConfiguration('last_month', $curr);
		displayMessage('{--ADMIN_BEG_WITHDRAW_PREPARED--}');
	} // END - if

	// Init variable
	$lastOnline = '';

	// Autopurge installed?
	if ((isExtensionActive('autopurge')) && (isBegActiveEnabled()) && ((getApInactiveSince() > 0))) {
		// Use last online timestamp to keep inactive members away from here
		$lastOnline   = ' AND (UNIX_TIMESTAMP() - `last_online`) >= {?ap_inactive_since?}';
	} // END - if

	// Check if at least one is in the active rallye
	$result = SQL_QUERY("SELECT `userid`, `gender`, `surname`, `family`, `email`, `beg_points`, `last_online`
FROM
	`{?_MYSQL_PREFIX?}_user_data`
WHERE
	`status`='CONFIRMED' AND
	`beg_points` > 0
	" . $lastOnline . "
ORDER BY
	`beg_points` DESC,
	`last_online` DESC,
	`userid` ASC", __FILE__, __LINE__);

	if (!SQL_HASZERONUMS($result)) {
		// List users
		$OUT = ''; $count = 1; $total = '0';
		while ($content = SQL_FETCHARRAY($result)) {
			// Init variables
			$WIN1 = ''; $WIN2 = '';

			// Maybe he can win his active beg?
			if ($count <= getBegRanks()) {
				// Mark him
				$WIN1 = '<strong>';
				$WIN2 = '</strong>';
			} // END - if

			// Prepare content
			$content = array(
				'userid'      => $content['userid'],
				'email'       => generateEmailLink($content['email'], 'user_data'),
				'gender'      => $content['gender'],
				'turbo'       => $content['beg_points'],
				'last_online' => generateDateTime($content['last_online'], 2),
				'win1'        => $WIN1,
				'win2'        => $WIN2,
				'cnt'         => $count,
			);

			// Load template and add it
			$OUT .= loadTemplate('admin_list_beg_rows', true, $content);
			$count++; $total += $content['beg_points'];
		} // END - while

		$content['rows']  = $OUT;
		$content['total_points'] = $total;

		// Check if we need to display form or not with manuel withdraw
		if (getLastMonth() == getMonth()) {
			// Load form
			$content['withdraw_form'] = loadTemplate('admin_list_beg_form', true);
		} else {
			// Display message "no manual withdraw possible"
			$content['withdraw_form'] = displayMessage('{--ADMIN_BEG_ALREADY_WITHDRAW--}', true);
		}

		// Prepare constant for timemark
		if (isExtensionActive('autopurge')) {
			$content['autopurge_timeout'] = generateDateTime(time() - getApInactiveSince(), 2);
		} else {
			$content['autopurge_timeout'] = displayMessage('{%pipe,generateExtensionInactiveNotInstalledMessage=autopurge%}', true);
		}

		// Load final template
		loadTemplate('admin_list_beg', false, $content);
	} else {
		// No one has joined the begging rallye...
		displayMessage('{--ADMIN_BEG_NO_RALLYE--}');
	}
} else {
	// Rallye deactivated
	displayMessage('{--ADMIN_BEG_RALLYE_DEACTIVATED--}');
}

// [EOF]
?>
