<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 11/15/2003 *
 * ===================                          Last change: 04/02/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-usage.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Auto-detection of usage statistics               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Automatische Erkennung der Aufrufstatistiken     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

// Base directory (should be moved to database)
$usage = getConfig('usage_base') . '/';

// Init FQFN
$FQFN = sprintf("%s%s/index.html",
	getPath(),
	getConfig('usage_base')
);

if (isGetRequestParameterSet('image')) {
	if (getRequestParameter('type') == 'usage') {
		$FQFN = sprintf("%s%s/usage.png",
			getPath(),
			getConfig('usage_base')
		);
	} else {
		if (strpos(getRequestParameter('image'), "\\") > 0) setGetRequestParameter('image', substr(getRequestParameter('image'), 0, strpos(getRequestParameter('image'), "\\")));
		$FQFN = sprintf("%s%s/%s_usage_%s.png",
			getPath(),
			getConfig('usage_base'),
			getRequestParameter('type'),
			getRequestParameter('image')
		);
	}

	if (isFileReadable($FQFN)) {
		$image = imagecreatefrompng($FQFN);
		setContentType('image/png');
		imagepng($image);
		imagedestroy($image);
	} // END - if
	shutdown();
} elseif (isGetRequestParameterSet('usage')) {
	$FQFN = sprintf("%s%s/usage_%s.html",
		getPath(),
		getConfig('usage_base'),
		getRequestParameter('usage')
	);
}

if ((!empty($FQFN)) && (isFileReadable($FQFN))) {
	// @TODO This code is double, see loadTemplate() and loadEmailTemplate() in functions.php
	eval('$content="' . SQL_ESCAPE(readFromFile($FQFN)) . '";');
	// Until here...

	// Replace URLs
	$content = str_replace('usage.png'    , '{?URL?}/modules.php?module=admin&amp;what=' . getWhat() . '&amp;type=usage&amp;image=usage', $content);
	$content = str_replace('daily_usage_' , '{?URL?}/modules.php?module=admin&amp;what=' . getWhat() . '&amp;type=daily&amp;image='     , $content);
	$content = str_replace('hourly_usage_', '{?URL?}/modules.php?module=admin&amp;what=' . getWhat() . '&amp;type=hourly&amp;image='    , $content);
	$content = str_replace('ctry_usage_'  , '{?URL?}/modules.php?module=admin&amp;what=' . getWhat() . '&amp;type=ctry&amp;image='      , $content);
	$content = str_replace('usage_'       , '{?URL?}/modules.php?module=admin&amp;what=' . getWhat() . '&amp;usage='                    , str_replace('.html', '', $content));
	$test = strtolower($content);

	// Do we need to strip out above and including <body> plus trailing </html> tag?
	if ((strpos($test, '<body') > 0) && (strpos($test, '</body>') > 0)) {
		// Okay, then do so.
		$content = substr(substr($content, 0, $body_end), $body_start);
		$content = substr($content, strpos($content, '>') + 1);
	} // END - if

	// Output code
	outputHtml($content);
} else {
	// Nothing to load, then we have no directory 'usage'
	displayMessage('{--ADMIN_USAGE_DIRECTORY_404--}');
}

// [EOF]
?>
